# -*- encoding: UTF-8 -*-
r"""
^0 nulis
1 vienas
2 du
3 trys
4 keturi
5 penki
6 šeši
7 septyni
8 aštuoni
9 devyni
10 dešimt
11 vienuolika
12 dvylika
13 trylika
14 keturiolika
15 penkiolika
16 šešiolika
17 septyniolika
18 aštuoniolika
19 devyniolika

2(\d) dvidešimt[ $1]
3(\d) trisdešimt[ $1]
([4-9])(\d) $1|asdešimt[ $2]

1(\d\d) vienas šimtas[ $1]
([2-9])(\d\d) $1 šimtai[ $2]

1(\d{3}) vienas tūkstantis[ $1]
(\d?1\d|\d?\d?0)(\d{3}) $1 tūkstančių[ $2]
(\d?\d1)(\d{3}) $1 tūkstantis[ $2]
(\d{1,3})(\d{3}) $1 tūkstančiai[ $2]

(\d?1\d|\d?\d?0)(\d{6}) $1 milijonų[ $2]
(\d?\d?1)(\d{6}) $1 milijonas[ $2]
(\d{1,3})(\d{6}) $1 milijonai[ $2]

(\d?1\d|\d?\d?0)(\d{9}) $1 milijardų[ $2]
(\d?\d?1)(\d{9}) $1 milijardas[ $2]
(\d{1,3})(\d{9}) $1 milijardai[ $2]

(\d?1\d|\d?\d?0)(\d{12}) $1 trilijonų[ $2]
(\d?\d?1)(\d{12}) $1 trilijonas[ $2]
(\d{1,3})(\d{12}) $1 trilijonai[ $2]

(\d?1\d|\d?\d?0)(\d{15}) $1 kvadrilijonų[ $2]
(\d?\d?1)(\d{15}) $1 kvadrilijonas[ $2]
(\d{1,3})(\d{15}) $1 kvadrilijonai[ $2]

(\d?1\d|\d?\d?0)(\d{18}) $1 kvintilijonų[ $2]
(\d?\d?1)(\d{18}) $1 kvintilijonas[ $2]
(\d{1,3})(\d{18}) $1 kvintilijonai[ $2]

# negative numbers

[-−](\d+) minus |$1

# decimals
# before delimiter
([-−]?(1|\d*[02-9]1))[.,] $1| sveikas
([-−]?\d*[2-9])[.,] $1| sveiki
(0|[-−]?\d*(1[1-9]|[1-9]0))[.,] $1| sveikų

# atfer delimiter
"([-−]?\d+[.,])(1)" $1| ir |$(f:$2) dešimtoji
"([-−]?\d+[.,])([2-9])" $1| ir |$(f:$2) dešimtosios
"([-−]?\d+[.,])([02-9]1)" $1| ir |$(f:$2) šimtoji
"([-−]?\d+[.,])(1[1-9]|[1-9]0)" $1| ir |$(f:$2) šimtųjų
"([-−]?\d+[.,])([02-9][2-9])" $1| ir |$(f:$2) šimtosios
"([-−]?\d+[.,])(\d[02-9]1)" $1| ir |$(f:$2) tūkstantoji
"([-−]?\d+[.,])(\d1[1-9]|[1-9]0)" $1| ir |$(f:$2) tūkstantųjų
"([-−]?\d+[.,])(\d[02-9][2-9])" $1| ir |$(f:$2) tūkstantosios

# female conversion
f:(.*)as \1a
f:(.*)du \1dvi
f:(.*)i \1ios
f:(.*) \1

# currency
# unit/subunit singular/plural_a/plural_b
us:([^,]*),([^,]*),([^,]*),([^,]*),([^,]*),([^,]*) \1
upa:([^,]*),([^,]*),([^,]*),([^,]*),([^,]*),([^,]*) \2
upb:([^,]*),([^,]*),([^,]*),([^,]*),([^,]*),([^,]*) \3
ss:([^,]*),([^,]*),([^,]*),([^,]*),([^,]*),([^,]*) \4
spa:([^,]*),([^,]*),([^,]*),([^,]*),([^,]*),([^,]*) \5
spb:([^,]*),([^,]*),([^,]*),([^,]*),([^,]*),([^,]*) \6

LTL:(\D+) $(\1: litas, litų, litai, centas, centų, centai)
EUR:(\D+) $(\1: euras, eurų, eurai, euro centas, euro centų, euro centai)
USD:(\D+) $(\1: doleris, dolerių, doleriai, centas, centų, centai)
NOK:(\D+) $(\1: Norvegijos krona, Norvegijos kronų, Norvegijos kronos, erė, erių, erės)
SEK:(\D+) $(\1: Švedijos krona, Švedijos kronų, Švedijos kronos, erė, erių, erės)
GBP:(\D+) $(\1: svaras sterlingų, svarų sterlingų, svarai sterlingų, pensas, pensų, pensai)
RUB:(\D+) $(\1: rublis, rublių, rubliai, kapeika, kapeikų, kapeikos)

# female gender
# before delimiter
"(NOK|SEK) ([-−]?(1|\d*[02-9]1))([.,]00?)?" $(f:$2)|$(\1:us) 				# 1| *01| *21 ...
"(NOK|SEK) ([-−]?(0|\d*(1[1-9]|[01-9]0)))([.,]00?)?" $2|$(\1:upa)			# 0 | *11| *19| *10| *30 ...
"(NOK|SEK) ([-−]?\d*[2-9])([.,]00?)?" $(f:$2)|$(\1:upb)					# *2| *8 ...

# atfer delimiter
"((NOK|SEK|RUB) [-−]?\d+)[.,](01)" $1| ir |$(f:$(1))$(\2:ss) 				# *,01 convertion to *,1
"((NOK|SEK|RUB) [-−]?\d+)[.,]([2-9]1)" $1| ir |$(f:$3)|$(\2:ss)				# 21, 51, 91 ...
"((NOK|SEK|RUB) [-−]?\d+)[.,](\d)" $1| ir |$(\30)$(\2:spa)				# *,2 | *,3 ... convertion to *,20 | *,30 ...
"((NOK|SEK|RUB) [-−]?\d+)[.,](1[1-9])" $1| ir |$3|$(\2:spa)				# 11-19
"((NOK|SEK|RUB) [-−]?\d+)[.,](\d\d)" $1| ir |$(f:$3)$(\2:spb)				# all the rest

# male gender (all except female gender filter matches)
# before delimiter
"([A-Z]{3}) ([-−]?(1|\d*[02-9]1))([.,]00?)?" $2|$(\1:us)
"([A-Z]{3}) ([-−]?0|\d*(1[1-9]|[01-9]0))([.,]00?)?" $2|$(\1:upa)
"([A-Z]{3}) ([-−]?\d*[2-9])([.,]00?)?" $2|$(\1:upb)

# atfer delimiter
"(([A-Z]{3}) [-−]?\d+)[.,](01)" $1| ir |$(1)$(\2:ss)
"(([A-Z]{3}) [-−]?\d+)[.,]([2-9]1)" $1| ir |$3|$(\2:ss)
"(([A-Z]{3}) [-−]?\d+)[.,](\d)" $1| ir |$(\30)$(\2:spa)
"(([A-Z]{3}) [-−]?\d+)[.,](1[1-9])" $1| ir |$3|$(\2:spa)
"(([A-Z]{3}) [-−]?\d+)[.,](\d\d)" $1| ir |$3$(\2:spb)

== feminine ==

([-−]?\d+)	$(feminine $1)
(.*)vienas	\1viena
(.*)du		\1dvi
(.*)i		\1ios

== masculine ==

([-−]?\d+)	$1

== ordinal ==

([-−]?\d+)	$(ordinal $1)

(.*)vienas	\1pirmas
(.*)du		\1antras
(.*)trys	\1trečias
(.*)keturi	\1ketvirtas
(.*)penki	\1penktas
(.*)šeši	\1šeštas
(.*)septyni	\1septintas
(.*)aštuoni	\1aštuntas
(.*)devyni	\1devintas
(.*)dešimt	\1dešimtas
(.*)lika	\1liktas
(.*)šimt	\1šimtas
(.*)		\1	# FIXME (tūkstančių etc.)

== ordinal-masculine ==

([-−]?\d+)	$(ordinal $1)

== ordinal-feminine ==

([-−]?\d+)	$(ordinal-feminine $(ordinal $1))

(.*)tasis	\1toji
(.*)s		\1
(.*)		\1	# FIXME (tūkstančių etc.)

== ordinal-number(-masculine)? ==

(\d+)	 \2as

== ordinal-number-feminine ==

(\d+)	 \1a

== help ==

"" $(help feminine)$(help masculine)$(help ordinal-feminine)$(help ordinal-masculine)$(help ordinal-number-feminine)$(help ordinal-number-masculine)
(feminine|masculine|ordinal(-feminine|-masculine|-number|-number-masculine|-number-feminine)?) \1: $(\1 1), $(\1 2), $(\1 3)\n
"""
from __future__ import unicode_literals
